;description: general support for scheme objects

;(define-module (alterator object)
;	       :export ())

(use-modules (srfi srfi-2) (ice-9 syncase))


(define (mark-procedure func type)
  (set-procedure-property! func 'type type)
  func)

(define (check-procedure func type)
  (and-let* ((ftype (procedure-property func 'type)))
	    (eq? ftype type)))

(define-syntax object
  (syntax-rules()
    ((_ <classname> ((<op> <self> <args> ... ) <exp1> <exp2> ... )  ... )
     (let ((table (list (cons '<op>
			      (lambda (<self> <args> ...) <exp1> <exp2> ...))
			...)))
       (letrec ((self
		  (lambda (op . args)
		    (let ((operation
			    (cond
			      ((assq op table) => cdr)
			      (else (assq '<classname> table)))))
		      (and operation
			   (apply operation self args))))))
	 self)))))


